#version 120
//
// pass1.vert
//

varying vec4 ambient;                                                 // ̔ˌ A
varying vec4 diffuse;                                                 // gUˌ D
varying vec4 specular;                                                // ʔˌ S

void main(void)
{
  vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);
  vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
  
  vec3 light = normalize(gl_LightSource[0].position.xyz - position);  // ̓_ɌxNg L
  vec3 view = -normalize(position);                                   // ̓_王_ɌxNg V
  vec3 halfway = normalize(light + view);                             // ԃxNg H
  
  float nl = dot(normal, light);
  float nh = pow(dot(normal, halfway), gl_FrontMaterial.shininess);

  // 
  ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
  
  // gUˌ
  diffuse = gl_FrontMaterial.diffuse * vec4(vec3(nl), 1.0) * gl_LightSource[0].diffuse;

  // ʔˌ
  specular = gl_FrontMaterial.specular * vec4(vec3(nh), 1.0) * gl_LightSource[0].specular;

  gl_Position = ftransform();                                         // _ʒu̍Wϊ
}
